%global bash_completions_dir %{_datadir}/bash-completion/completions
%global fish_completions_dir %{_datadir}/fish/vendor_completions.d
%global zsh_completions_dir %{_datadir}/zsh/site-functions

%global debug_package %{nil}
%global golangver 1.23.1

# https://github.com/helmfile/helmfile
%global  goipath    github.com/helmfile/helmfile
%global  forgeurl   https://github.com/helmfile/helmfile
Version: 0.171.0

%if 0%{?rhel} == 8
%global gobuilddir      %{_builddir}/%{name}-%{version}/_build 
%endif

%gometa

Name: helmfile
Release: 3%{?dist}
Summary: Declarative spec for deploying helm charts

License: MIT
URL: https://github.com/helmfile/helmfile
Source0: %{url}/releases/tag/v%{version}/%{name}-%{version}.tar.gz
Source1: %{name}-%{version}-vendor.tar.gz
BuildRequires:  golang >= %{golangver}
%if 0%{?fedora} || 0%{?rhel} > 8
BuildRequires:  go-rpm-macros
%endif

%description
Declaratively deploy your Kubernetes manifests, Kustomize configs, and
Charts as Helm releases. Generate all-in-one manifests for use with ArgoCD.

%prep
%if 0%{?rhel} == 8
%autosetup %{forgesetupargs}
install -m 0755 -vd %{gobuilddir}/bin %{gobuilddir}/src/$(dirname %{goipath})
ln -s "$(pwd)" %{gobuilddir}/src/%{goipath}
%else
%goprep
%endif
%setup -q -T -D -a1 %{forgesetupargs}

%if 0%{?fedora} || 0%{?rhel} > 8
%generate_buildrequires
%endif

%build
GOAMD64=v2
CGO_CPPFLAGS='-D_FORTIFY_SOURCE=2 -fstack-protector-all'
GO111MODULE=on 
go build -mod=vendor -buildmode=pie -compiler gc '-tags=rpm_crashtraceback libtrust_openssl ' -a -v -x \
	-ldflags="-s -w -X go.szostok.io/version.version=%{version} -X go.szostok.io/version.dirtyBuild=false" \
	-o %{gobuilddir}/bin/%{name}


%{gobuilddir}/bin/%{name} completion bash > %{name}.bash
%{gobuilddir}/bin/%{name} completion fish > %{name}.fish
%{gobuilddir}/bin/%{name} completion zsh  > %{name}.zsh

%install
install -p -D %{gobuilddir}/bin/%{name} %{buildroot}%{_bindir}/%{name}
install -Dpm 0644 %{name}.bash %{buildroot}%{bash_completions_dir}/%{name}
install -Dpm 0644 %{name}.fish %{buildroot}%{fish_completions_dir}/%{name}.fish
install -Dpm 0644 %{name}.zsh  %{buildroot}%{zsh_completions_dir}/_%{name}

%files
%doc CODEOWNERS CONTRIBUTING.md README.md SECURITY.md USERS.md examples docs
%license LICENSE
%{_bindir}/%{name}
%{bash_completions_dir}/%{name}
%{fish_completions_dir}/%{name}.fish
%{zsh_completions_dir}/_%{name}

%changelog
* Mon Mar 17 2025 sheePackager <packager@shee.org> - 0.171.0-1
- Build for EL

